# -*- coding: utf-8 -*-
"""dlipr20_ex02_classification.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1MPpyitw_YZFAsUvOFFN3PuKvVhY-92Fc
"""

# ==============================================================================
# Constants, Imports
# ==============================================================================
# ------------------------------------------------------------------------------
# constants
COMET_EXPERIMENT = True
NOTEBOOK = False

# Commented out IPython magic to ensure Python compatibility.
# ------------------------------------------------------------------------------
# for notebook (eg google colab) only needed if comet_ml not installed yet
if COMET_EXPERIMENT and NOTEBOOK:
    pass # else replace with:
#     %pip install comet_ml
# if installed for first time, restart notebook now

# ------------------------------------------------------------------------------
# setup comet experiment

# import comet_ml in the top of your file
if COMET_EXPERIMENT:
  from comet_ml import Experiment
    
  # Add the following code anywhere in your machine learning file
  experiment = Experiment(api_key="EnterYourAPIKey",
                          project_name="exercise2", workspace="irratzo")
  
def printcomet(string : str = ""):
  print(string)
  if COMET_EXPERIMENT:
    experiment.log_text(string)

"""
---------------------------------------------------
Exercise 2 - Classification
---------------------------------------------------
Suppose we want to classify some data (4 samples) into 3 distinct classes: 0, 1, and 2.
We have set up a network with a pre-activation output z in the last layer.
Applying softmax will give the final model output.
input X ---> some network --> z --> y_model = softmax(z)

We quantify the agreement between truth (y) and model using categorical cross-entropy.
J = - sum_i (y_i * log(y_model(x_i))

In the following you are to implement softmax and categorical cross-entropy
and evaluate them values given the values for z.
"""
import numpy as np
import tensorflow as tf

# Data: 4 samples with the following class labels (input features X irrelevant here)
y_cl = np.array([0, 0, 2, 1])

# output of the last network layer before applying softmax
z = np.array([
    [4,    5,    1],
    [-1,  -2,   -3],
    [0.1, 0.2, 0.3],
    [-1,  17,    1]
    ]).astype(np.float32)

# TensorFlow implementation as reference. Make sure you get the same results!
printcomet('\nTensorFlow 2.0 ------------------------------ ')


def crossentropy(x, y):
    return tf.reduce_mean(-tf.reduce_sum(y * tf.math.log(x), axis=1))


y_tf = tf.one_hot(y_cl, 3)
printcomet("y one_hot:\n{}".format(y_tf))
y_model_tf = tf.nn.softmax(z)
crossent_tf = crossentropy(y_model_tf, y_tf)

printcomet('softmax(z)')
printcomet(y_model_tf)
printcomet('cross entropy {}'.format(crossent_tf))

printcomet('\nMy solution ------------------------------ ')
# 1) Write a function that turns any class labels y_cl into one-hot encodings y.
#    0 --> (1, 0, 0)
#    1 --> (0, 1, 0)
#    2 --> (0, 0, 1)
#    Make sure that np.shape(y) = (4, 3) for np.shape(y_cl) = (4).


def to_onehot(y_cl, num_classes):
    y = np.zeros((len(y_cl), num_classes))
    for i, cl in enumerate(y_cl):
      y[i][cl] = 1
    return y

# 2) Write a function that returns the softmax of the input z along the last axis.
def softmax(z):
    z_softmax = z.copy()
    (num_rows, num_columns) = z.shape
    # num_rows corresponds to num_labels y1, y2, ...
    # num_columns corresponds to num_classes cl1, cl2, ...
    for i_row in range(num_rows):
        row = z[i_row, :]
        exp_row = np.exp(row)
        normalization = np.sum(exp_row)
        z_softmax[i_row, :] = exp_row / normalization
    return z_softmax

# 3) Compute the categorical cross-entropy between data and model.
def cross_entropy(y_model, y):
  product = y * np.log(y_model)
  sum = np.sum(product, axis=-1)
  return -1 * np.mean(sum)
  
y_np = to_onehot(y_cl, num_classes=3)
printcomet("y one_hot:\n{}".format(y_np))
y_model_np = softmax(z)
crossent_np = cross_entropy(y_model_np, y_np)

printcomet('softmax(z)')
printcomet(y_model_np)
printcomet('cross entropy {}'.format(crossent_np))

# check that tensorflow and numpy implementation yield the same interim results
# using the default tolerances rtol=1e-5, atol=1e-8.
try:
    assert np.array_equal(y_tf.numpy(), y_np)
    assert np.allclose(y_model_tf.numpy(), y_model_np, rtol=1e-5, atol=1e-8)
    assert np.allclose(crossent_tf.numpy(), crossent_np, rtol=1e-5, atol=1e-8)
    printcomet("All interim results are identical to the tensorflow implementation.")
except:
    printcomet("Some interim results are NOT identical to the tensorflow implementation.")

# 4) Which classes are predicted by the model (maximum entry).
y_predicted = np.argmax(y_model_np, axis=1) # columns

# 5) How many samples are correctly classified (accuracy)?
mask = (y_predicted == y_cl) # bool [True, False, ...]
accuracy = np.sum(mask) / len(mask)
printcomet("label predictions: {}".format(mask))
printcomet("accuracy : {}".format(accuracy))

# #################
if COMET_EXPERIMENT:
    experiment.end()
